unit AutoTable;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, mdmailslot;

const
  MAX_MAILSLOT = 10;

type
  TAutoTable = class(TTable)
  private
    { Dclarations prives }
    FMailSlot : TmdSecureMail;
    FBackAutoRefresh : boolean;
    FAutoRefresh     : boolean;
    FServer          : string;
  protected
    { Dclarations protges }
    procedure MsgAvail(Sender: TObject; Msg: String);
    procedure DoAfterOpen; override;
    procedure DoAfterClose; override;
    procedure InternalPost; override;
    procedure InternalEdit; override;
    procedure InternalCancel; override;
    procedure InternalDelete; override;
  public
    { Dclarations publiques }
    constructor Create(Aowner : TComponent); override;
  published
    { Dclarations publies }
    property AutoRefresh : boolean read FAutoRefresh write FAutoRefresh;
    property Server      : string read FServer write FServer;
  end;

procedure Register;

implementation

constructor TAutoTable.Create(Aowner : TComponent);
begin
  inherited Create(AOwner);
  FAutoRefresh:=true;
  FBackAutoRefresh:=FAutoRefresh;
  FServer:='.';
end;

procedure TAutoTable.InternalEdit;
begin
  FBackAutoRefresh:=FAutoRefresh;
  FAutoRefresh:=false;
  inherited;
end;

procedure TAutoTable.InternalCancel;
begin
  FBackAutoRefresh:=FAutoRefresh;
  FAutoRefresh:=false;
  inherited;
end;

procedure TAutoTable.InternalDelete;
var mt, t : string;
    i : integer;
begin
  FAutoRefresh:=FBackAutoRefresh;
  inherited;
  mt:=ExtractFileName(TableName);
  if length(mt)>5 then mt:=copy(mt,1,5);
  for i:=0 to MAX_MAILSLOT do begin
    t:=mt+inttostr(i);
    if t<>FMailSlot.slot then SendSecureMail(FServer,t,'Refresh');
  end;
end;

procedure TAutoTable.InternalPost;
var mt, t : string;
    i : integer;
begin
  FAutoRefresh:=FBackAutoRefresh;
  inherited;
  mt:=ExtractFileName(TableName);
  if length(mt)>5 then mt:=copy(mt,1,5);
  for i:=0 to MAX_MAILSLOT do begin
    t:=mt+inttostr(i);
    if t<>FMailSlot.slot then SendSecureMail(FServer,t,'Refresh');
  end;
end;

procedure TAutoTable.DoAfterOpen;
var
  ok : boolean;
  mt, t : string;
  i : integer;
begin
  inherited;
  FMailSlot:=TmdSecureMail.create(self);
  with FMailSlot do begin
    ok:=false;
    mt:=ExtractFileName(self.TableName);
    if length(mt)>5 then mt:=copy(mt,1,5);
    i:=0;
    while not ok do begin
      try
        t:=mt+inttostr(i);
        Slot:=t;
        open;
        ok:=true;
      except
        on e:emdmailslot do begin
          inc(i);
          if i>MAX_MAILSLOT then begin
            raise Exception.Create('Trop de mailslots sur la table '+tablename);
          end;
        end;
      end;
    end;
    OnMessageAvail:=MsgAvail;
  end;
end;

procedure TAutoTable.DoAfterClose;
begin
  inherited;
  FMailSlot.destroy;
end;

procedure TAutoTable.MsgAvail(Sender: TObject; Msg: String);
begin
  if not FAutoRefresh then exit;
  if msg='Refresh' then begin
    Refresh;
  end;
end;

procedure Register;
begin
  RegisterComponents('Steff', [TAutoTable]);
end;

end.
